package com.slawacoste.app;

import java.sql.SQLException;
import java.sql.Statement;

public class TableMaker {

    static void makeTables(Statement statement) throws SQLException {
        makeTypesTable(statement);
        makeGoodsTable(statement);
        makeMallsTable(statement);
    }

    private static void makeTypesTable(Statement statement) throws SQLException {
        String sql = "CREATE TABLE Types" +
                "(type_id INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY, " +
                "name VARCHAR(255) NOT NULL UNIQUE)";
        statement.executeUpdate(sql);
    }

    private static void makeGoodsTable(Statement statement) throws SQLException {
        String sql = "CREATE TABLE Goods" +
                "(good_id INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY, " +
                "name VARCHAR(255) NOT NULL UNIQUE CONSTRAINT name_length CHECK (char_length(name)>=3), " +
                "type_id INTEGER NOT NULL DEFAULT 1, " +
                "description VARCHAR(255) NOT NULL DEFAULT 'xxx', " +
                "price DECIMAL (8,2) NOT NULL DEFAULT 1.00, " +
                "FOREIGN KEY (type_id) REFERENCES Types (type_id))";
        statement.executeUpdate(sql);
    }

    private static void makeMallsTable(Statement statement) throws SQLException {
        String sql = "CREATE TABLE Malls" +
                "(mall_id INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY, " +
                "city VARCHAR(255) NOT NULL, " +
                "address VARCHAR(255) NOT NULL)";
        statement.executeUpdate(sql);
    }

    static void makeStoresTable(Statement statement) throws SQLException {
        String sql = "CREATE TABLE Stores " +
                "AS (SELECT Malls.mall_id, Goods.good_id FROM Malls CROSS JOIN Goods)";
        statement.executeUpdate(sql);
        String alter = "ALTER TABLE Stores ADD PRIMARY KEY (mall_id, good_id), " +
                "ADD FOREIGN KEY (mall_id) REFERENCES Malls (mall_id), " +
                "ADD FOREIGN KEY (good_id) REFERENCES Goods (good_id), " +
                "ADD COLUMN amount INTEGER";
        statement.executeUpdate(alter);
    }

}
